/* IBM Confidential
 * OCO Source Materials
 * 5724-N40, 5724-N41, 5724-N42, 5724-N43, 5724-L77, 5724-L78, 5724-L79, 5724-L80, 5724-L81, 5724-L82
 *  Copyright IBM Corporation 2007
 * The source code for this program is not published or otherwise
 * divested of its trade secrets, irrespective of what has been
 * deposited with the U.S. Copyright Office.
 */
package com.ibm.j2ca.migration.sap.v602_to_v610;

import org.apache.xerces.parsers.DOMParser;
import org.eclipse.core.resources.IFile;
import org.eclipse.core.runtime.IProgressMonitor;
import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.NodeList;

import com.ibm.j2ca.migration.ArtifactChangeArguments;
import com.ibm.j2ca.migration.Change;
import com.ibm.j2ca.migration.IChangeArguments;
import com.ibm.j2ca.migration.util.Util;

public class SAPAppendXPathChange extends Change {
	public static final String COPYRIGHT = " Copyright IBM Corporation 2008."; //$NON-NLS-1$
	
	private IFile file;
	
	public SAPAppendXPathChange(IFile file, SAPAppendXPath changeData) {
		super(changeData);
		this.file = file;
	}
	
	public SAPAppendXPath getChangeData() { return (SAPAppendXPath)super.getChangeData(); }
	
	public IChangeArguments getChangeArguments() {
		ArtifactChangeArguments argument = new ArtifactChangeArguments(file);
		return argument;
	}
	
	public String getChangeDetails() {		
		return MigrationMessages.SAPAppendXPathChange_Details;
	}
	
	public void perform(IProgressMonitor pm) throws Exception {
		if(file.exists()) {
			String boName = Util.getBusinessObjectName(file);
			
			DOMParser parser = new DOMParser();				
			parser.parse(file.getLocation().toString());				
			Document doc = parser.getDocument();
			
			NodeList nlErrorParameter = doc.getElementsByTagNameNS("*", "ErrorParameter");
			for(int i=0; i<nlErrorParameter.getLength(); i++) {
				Element eErrorParameter = (Element)nlErrorParameter.item(i);
				String oldValue = getNodeText(eErrorParameter);
				String newValue = boName + "/" + oldValue;
				eErrorParameter.setTextContent(newValue);
			}
			
			writeXml(file, doc);
			
		}
	}
}
