/* IBM Confidential
 * OCO Source Materials
 * 5724-N40, 5724-N41, 5724-N42, 5724-N43, 5724-L77, 5724-L78, 5724-L79, 5724-L80, 5724-L81, 5724-L82
 *  Copyright IBM Corporation 2008
 * The source code for this program is not published or otherwise
 * divested of its trade secrets, irrespective of what has been
 * deposited with the U.S. Copyright Office.
 */

package com.ibm.j2ca.migration.sap.wbi_to_v610;

import java.util.ArrayList;

import org.eclipse.core.resources.IFile;
import org.eclipse.core.resources.IProject;
import org.eclipse.core.resources.IResource;

import com.ibm.j2ca.migration.IChange;
import com.ibm.j2ca.migration.changedata.CreateFile;
import com.ibm.j2ca.migration.internal.changes.wbi.CreateBOWrapperBGChange;
import com.ibm.j2ca.migration.util.Util;

public class CreateBOWrapperBGForSAP extends CreateFile {
	public static final String COPYRIGHT = " Copyright IBM Corporation 2008."; //$NON-NLS-1$

	public String includeBoNameRegEx = ".*\\.xsd";
	public String excludeBoNameRegEx = "(WICSFault.xsd|MO_.*\\.xsd|.*\\BG.xsd)";
	public String baseNamespace = null;
	public boolean topLevelOnly = true;
	public String sapAPI = "BAPI";

	public CreateBOWrapperBGForSAP(String sourceBOPath, String sourceBundleName, String baseNamespace, boolean topLevelOnly) {
		super(sourceBOPath, sourceBundleName, ModulePath.BO);
		this.baseNamespace = baseNamespace;
		this.topLevelOnly = topLevelOnly;
	}

	public CreateBOWrapperBGForSAP(String sourceBOPath, String sourceBundleName, String includeBoNameRegEx, String excludeBoNameRegEx, String baseNamespace, boolean topLevelOnly) {
		super(sourceBOPath, sourceBundleName, ModulePath.BO);
		this.includeBoNameRegEx = includeBoNameRegEx;
		this.excludeBoNameRegEx = excludeBoNameRegEx;
		this.baseNamespace = baseNamespace;
		this.topLevelOnly = topLevelOnly;
	}

	public ArrayList<IChange> createChanges(IResource resource, ModuleType[] projectModuleTypes) {
		ArrayList<IChange> changes = new ArrayList<IChange>();
		if(resource instanceof IProject) {
			IProject project = (IProject)resource;
			
			if(matchesModuleTypes(projectModuleTypes)) {
				changes.add(new CreateBOWrapperBGForSAPChange(project, this));				
			}
		}
		return changes;
	}

}
